using System;
using System.Data;
using Microsoft.Data.Odbc;


namespace ConsoleApplication1
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
    
    /// </summary>
		[STAThread]
		static void Main(string[] args)
		{
      OdbcConnection activeDb = new OdbcConnection ("DRIVER=MySQL ODBC 3.51 Driver;");
      activeDb.Open();
      OdbcCommand cmd = activeDb.CreateCommand();
			
      // Create table for this test if not existent
      cmd.CommandText = "create table if not exists test.temp3 (\n"+
        "query TEXT NOT NULL,\n" +
        "first VARCHAR (10)\n" + // can be null
        ") CHARACTER SET UTF8;";
      cmd.ExecuteNonQuery();

      // Set up insert command
      cmd.CommandText = "INSERT INTO temp3 VALUES (?, ?)";
      cmd.Parameters.Clear();
      cmd.Parameters.Add (new OdbcParameter("query", "here's a value"));
      // Attempt 1 - NullReference exception, then crash on execute
      cmd.Parameters.Add (new OdbcParameter("first", null));
      /* also tried 
      --------- Null reference exception, then crash on execute
           OdbcParameter x = new OdbcParameter("first", null);
           x.IsNullable = true;
           cmd.Add (x);
      --------- NullReference exception, then crash on execute
           OdbcParameter x = new OdbcParameter ();
           x.IsNullable = true;
           cmd.Add (x);
      --------- Conversion error; doesn't know how to use DBNull on constructor
           OdbcParameter x = new OdbcParameter ("first", DBNull.Value);
           cmd.Add (x);
      */
      cmd.ExecuteNonQuery(); 

		}
	}
}
